diff --git a/src/bin/pg_dump/pg_dump.h b/src/bin/pg_dump/pg_dump.h
index 1448005f30..e5155f760e 100644
--- a/src/bin/pg_dump/pg_dump.h
+++ b/src/bin/pg_dump/pg_dump.h
@@ -296,6 +296,7 @@ typedef struct _tableInfo
 	bool		dummy_view;		/* view's real definition must be postponed */
 	bool		postponed_def;	/* matview must be postponed into post-data */
 	bool		ispartition;	/* is table a partition? */
+	Oid			partitionparent; /* owning partitioned table, or 0 */
 
 	/*
 	 * These fields are computed only if we decide the table is interesting
diff --git a/src/bin/psql/describe.c b/src/bin/psql/describe.c
index 80d8338b96..7fde1114a0 100644
--- a/src/bin/psql/describe.c
+++ b/src/bin/psql/describe.c
@@ -2044,18 +2044,36 @@ describeOneTableDetails(const char *schemaname,
 		char	   *partdef;
 		char	   *partconstraintdef = NULL;
 
-		printfPQExpBuffer(&buf,
-						  "SELECT inhparent::pg_catalog.regclass,\n"
-						  "  pg_catalog.pg_get_expr(c.relpartbound, inhrelid)");
-		/* If verbose, also request the partition constraint definition */
-		if (verbose)
+		if (pset.sversion >= 120000)
+		{
+			printfPQExpBuffer(&buf,
+							  "SELECT p.parentrelid::pg_catalog.regclass,\n"
+							  "  pg_catalog.pg_get_expr(p.partbound, p.partrelid)");
+			/* If verbose, also request the partition constraint definition */
+			if (verbose)
+				appendPQExpBuffer(&buf,
+								  ",\n  pg_catalog.pg_get_partition_constraintdef(p.partrelid)");
 			appendPQExpBuffer(&buf,
-							  ",\n  pg_catalog.pg_get_partition_constraintdef(inhrelid)");
-		appendPQExpBuffer(&buf,
-						  "\nFROM pg_catalog.pg_class c"
-						  " JOIN pg_catalog.pg_inherits i"
-						  " ON c.oid = inhrelid"
-						  "\nWHERE c.oid = '%s' AND c.relispartition;", oid);
+							  "\nFROM pg_catalog.pg_class c"
+							  " JOIN pg_catalog.pg_partition p"
+							  " ON c.oid = p.partrelid"
+							  "\nWHERE c.oid = '%s' AND c.relpartitionparent <> 0;", oid);
+		}
+		else
+		{
+			printfPQExpBuffer(&buf,
+							  "SELECT inhparent::pg_catalog.regclass,\n"
+							  "  pg_catalog.pg_get_expr(c.relpartbound, inhrelid)");
+			/* If verbose, also request the partition constraint definition */
+			if (verbose)
+				appendPQExpBuffer(&buf,
+								  ",\n  pg_catalog.pg_get_partition_constraintdef(inhrelid)");
+			appendPQExpBuffer(&buf,
+							  "\nFROM pg_catalog.pg_class c"
+							  " JOIN pg_catalog.pg_inherits i"
+							  " ON c.oid = inhrelid"
+							  "\nWHERE c.oid = '%s' AND c.relispartition;", oid);
+		}
 		result = PSQLexec(buf.data);
 		if (!result)
 			goto error_return;
@@ -2984,7 +3002,25 @@ describeOneTableDetails(const char *schemaname,
 		}
 
 		/* print child tables (with additional info if partitions) */
-		if (pset.sversion >= 100000)
+		if (pset.sversion >= 120000)
+		{
+			if (tableinfo.relkind == RELKIND_PARTITIONED_TABLE)
+				printfPQExpBuffer(&buf,
+								  "SELECT c.oid::pg_catalog.regclass,"
+								  "       pg_catalog.pg_get_expr(p.partbound, p.partrelid),"
+								  "       c.relkind"
+								  " FROM pg_catalog.pg_class c, pg_catalog.pg_partition p"
+								  " WHERE c.oid=p.partrelid AND p.parentrelid = '%s'"
+								  " ORDER BY pg_catalog.pg_get_expr(p.partbound, p.partrelid) = 'DEFAULT',"
+								  "          c.oid::pg_catalog.regclass::pg_catalog.text;", oid);
+			else
+				printfPQExpBuffer(&buf,
+								  "SELECT c.oid::pg_catalog.regclass,NULL,c.relkind"
+								  " FROM pg_catalog.pg_class c, pg_catalog.pg_inherits i"
+								  " WHERE c.oid=i.inhrelid AND i.inhparent = '%s'"
+								  " ORDER BY c.oid::pg_catalog.regclass::pg_catalog.text;", oid);
+		}
+		else if (pset.sversion >= 100000)
 			printfPQExpBuffer(&buf,
 							  "SELECT c.oid::pg_catalog.regclass,"
 							  "       pg_catalog.pg_get_expr(c.relpartbound, c.oid),"
diff --git a/src/bin/psql/tab-complete.c b/src/bin/psql/tab-complete.c
index bb696f8ee9..b8dbc5b539 100644
--- a/src/bin/psql/tab-complete.c
+++ b/src/bin/psql/tab-complete.c
@@ -1134,6 +1134,7 @@ static const SchemaQuery Query_for_list_of_statistics = {
 "   SELECT 'DEFAULT' ) ss "\
 "  WHERE pg_catalog.substring(name,1,%%d)='%%s'"
 
+/* XXX fix this */
 /* the silly-looking length condition is just to eat up the current word */
 #define Query_for_partition_of_table \
 "SELECT pg_catalog.quote_ident(c2.relname) "\
diff --git a/src/include/catalog/heap.h b/src/include/catalog/heap.h
index c5e40ff017..d66a2f0b0d 100644
--- a/src/include/catalog/heap.h
+++ b/src/include/catalog/heap.h
@@ -149,7 +149,7 @@ extern void StorePartitionKey(Relation rel,
 				  Oid *partopclass,
 				  Oid *partcollation);
 extern void RemovePartitionKeyByRelId(Oid relid);
-extern void StorePartitionBound(Relation rel, Relation parent,
-					PartitionBoundSpec *bound);
+extern void MarkRelationPartitioned(Relation rel, Relation parent,
+					bool is_default);
 
 #endif							/* HEAP_H */
diff --git a/src/include/catalog/indexing.h b/src/include/catalog/indexing.h
index 24915824ca..a42c7041d5 100644
--- a/src/include/catalog/indexing.h
+++ b/src/include/catalog/indexing.h
@@ -339,6 +339,12 @@ DECLARE_UNIQUE_INDEX(pg_replication_origin_roname_index, 6002, on pg_replication
 DECLARE_UNIQUE_INDEX(pg_partitioned_table_partrelid_index, 3351, on pg_partitioned_table using btree(partrelid oid_ops));
 #define PartitionedRelidIndexId			 3351
 
+DECLARE_UNIQUE_INDEX(pg_partition_partrelid_index, 3998, on pg_partition using btree(partrelid oid_ops));
+#define PartitionRelidIndexId			 3998
+
+DECLARE_INDEX(pg_partition_parentrelid_index, 4001, on pg_partition using btree(parentrelid oid_ops));
+#define PartitionParentrelidIndexId			 4001
+
 DECLARE_UNIQUE_INDEX(pg_publication_oid_index, 6110, on pg_publication using btree(oid oid_ops));
 #define PublicationObjectIndexId 6110
 
diff --git a/src/include/catalog/partition.h b/src/include/catalog/partition.h
index 4b3b5ae770..8cbbd227f4 100644
--- a/src/include/catalog/partition.h
+++ b/src/include/catalog/partition.h
@@ -15,6 +15,7 @@
 
 #include "fmgr.h"
 #include "partitioning/partdefs.h"
+#include "storage/lock.h"
 #include "utils/relcache.h"
 
 /* Seed for the extended hash function */
@@ -35,6 +36,7 @@ typedef struct PartitionDescData
 
 extern Oid	get_partition_parent(Oid relid);
 extern List *get_partition_ancestors(Oid relid);
+extern List *get_partition_descendants(Oid relid, LOCKMODE lockmode);
 extern List *map_partition_varattnos(List *expr, int fromrel_varno,
 						Relation to_rel, Relation from_rel,
 						bool *found_whole_row);
diff --git a/src/include/catalog/pg_class.h b/src/include/catalog/pg_class.h
index dc6c415c58..a8f2cadcf6 100644
--- a/src/include/catalog/pg_class.h
+++ b/src/include/catalog/pg_class.h
@@ -66,7 +66,7 @@ CATALOG(pg_class,1259,RelationRelationId) BKI_BOOTSTRAP BKI_ROWTYPE_OID(83,Relat
 										 * not */
 	bool		relispopulated; /* matview currently holds query results */
 	char		relreplident;	/* see REPLICA_IDENTITY_xxx constants  */
-	bool		relispartition; /* is relation a partition? */
+	Oid			relpartitionparent; /* Oid of parent if partition, or 0 */
 	Oid			relrewrite;		/* heap for rewrite during DDL, link to
 								 * original rel */
 	TransactionId relfrozenxid; /* all Xids < this are frozen in this rel */
@@ -77,7 +77,6 @@ CATALOG(pg_class,1259,RelationRelationId) BKI_BOOTSTRAP BKI_ROWTYPE_OID(83,Relat
 	/* NOTE: These fields are not present in a relcache entry's rd_rel field. */
 	aclitem		relacl[1];		/* access permissions */
 	text		reloptions[1];	/* access-method-specific options */
-	pg_node_tree relpartbound;	/* partition bound node tree */
 #endif
 } FormData_pg_class;
 
diff --git a/src/include/catalog/toasting.h b/src/include/catalog/toasting.h
index f259890e43..7d3934865c 100644
--- a/src/include/catalog/toasting.h
+++ b/src/include/catalog/toasting.h
@@ -60,6 +60,7 @@ DECLARE_TOAST(pg_foreign_table, 4153, 4154);
 DECLARE_TOAST(pg_init_privs, 4155, 4156);
 DECLARE_TOAST(pg_language, 4157, 4158);
 DECLARE_TOAST(pg_namespace, 4163, 4164);
+DECLARE_TOAST(pg_partition, 3424, 3425);
 DECLARE_TOAST(pg_partitioned_table, 4165, 4166);
 DECLARE_TOAST(pg_policy, 4167, 4168);
 DECLARE_TOAST(pg_proc, 2836, 2837);
diff --git a/src/include/nodes/parsenodes.h b/src/include/nodes/parsenodes.h
index 07ab1a3dde..61b31fb2bb 100644
--- a/src/include/nodes/parsenodes.h
+++ b/src/include/nodes/parsenodes.h
@@ -803,7 +803,7 @@ typedef struct PartitionSpec
  * PartitionBoundSpec - a partition bound specification
  *
  * This represents the portion of the partition key space assigned to a
- * particular partition.  These are stored on disk in pg_class.relpartbound.
+ * particular partition.  These are stored on disk in pg_partition.partbound.
  */
 struct PartitionBoundSpec
 {
diff --git a/src/include/utils/rel.h b/src/include/utils/rel.h
index 6ecbdb6294..eb1858aa92 100644
--- a/src/include/utils/rel.h
+++ b/src/include/utils/rel.h
@@ -406,6 +406,12 @@ typedef struct ViewOptions
  */
 #define RelationGetRelid(relation) ((relation)->rd_id)
 
+/*
+ * RelationGetParentRelid
+ *		Returns the OID of the relations parent, or InvalidOid if the
+ *		relation has no parent
+ */
+#define RelationGetParentRelid(relation) ((relation)->rd_rel->relpartitionparent)
 /*
  * RelationGetNumberOfAttributes
  *		Returns the total number of attributes in a relation.
diff --git a/src/include/utils/syscache.h b/src/include/utils/syscache.h
index 4f333586ee..44d94f001a 100644
--- a/src/include/utils/syscache.h
+++ b/src/include/utils/syscache.h
@@ -73,6 +73,7 @@ enum SysCacheIdentifier
 	OPFAMILYAMNAMENSP,
 	OPFAMILYOID,
 	PARTRELID,
+	PARTSRELID,
 	PROCNAMEARGSNSP,
 	PROCOID,
 	PUBLICATIONNAME,
